/* Include file for G3 fax routines
   Copyright (C) 1990, 1995  Frank D. Cringle.

This file is part of g3view - an X11 fax viewer
     
g3view is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2 of the License, or (at your
option) any later version.
     
This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.
     
You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. */

#include <sys/types.h>
#include <X11/Xmd.h>

/* type used for pixel numbers */
typedef CARD16 pixnum;

/* fsm state codes */
#define S_Null		0
#define S_TermW		1
#define S_TermB		2
#define S_MakeUpW	3
#define S_MakeUpB	4
#define S_MakeUp	5
#define S_EOL		6

/* G3 compressed data descriptor */
struct G3desc {
    pixnum ypix;		/* height of document in pixels */
    pixnum xpix;		/* width of document in pixels */
    int Vres;			/* vertical resolution: 0 = standard, 1 = high */
    BYTE *Data;			/* in-memory copy of file */
    size_t Size;		/* length of Data */
};

/* state table entry */
struct tabent {
    unsigned char State;
    unsigned char Width;
    pixnum Param;
};

extern int verbose;

extern struct tabent WhiteTable[];	/* White run lengths */
extern struct tabent BlackTable[];	/* Black run lengths */

/* get memory or abort if none available */
extern char *xmalloc(unsigned int size);

#ifdef BSD
#ifndef rindex
#define rindex strrchr
#endif
#ifndef bcmp
#define memcmp bcmp
#endif
#endif
